/*
 * Author: Peter Keel <killer@discordia.ch>
 *
 * Prototype of a pulldown-menu
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <slang.h>
#include <signal.h>
#include "demolib.c"

#define BARHI 0 	/* "white","black"  */
#define BARLOW 1	/* "black","cyan"   */
#define MBORDER 1	/* "black","cyan"   */
#define MLOW 3		/* "white","cyan"   */
#define MHI 0		/* "white","black"  */
#define MHIHI 2		/* "yellow","black" */
#define MLOWHI 4	/* "yellow","cyan"  */

static int create_menu(int,int);
static int move_menu_up(int,int);
static int move_menu_down(int,int);
static int move_menu_top(int,int);
static int move_menu_bottom(int,int);

static int create_menubar();
static int move_menubar_left(int);
static int move_menubar_right(int);

static int input_box(int,int,int,int);

  char *menubar[] = {" Datei ", " Edit ", " Suchen ", " Befehl "};
  char *menu[][4] = {" Datei ", " Edit ", " Suchen ", " Befehl ",
                      " Load  ", " Cut   ", " Find  ", " Do    ", 
                      " Save  ", " Copy  ", " Again ", " Do it ",
		      " About ", " Paste ", " Regex ", " Don't ",
		      " Quit  ", " Erase ", "       ", " Panic "};
  
main(void){
  int ypos,xpos;
  int ch,x,y,ymin,ymax,xmin,xmax;
    xpos=0; ypos=0;
  demolib_init_terminal(1,1);
  
  create_mainscreen();  
  xpos=create_menubar(0);

    
while(1)
{
	SLkp_init;
	ch = SLkp_getkey();
	
	switch (ch) {
	    case '4':
	    case SL_KEY_LEFT:	create_mainscreen();
			    	create_menubar(xpos);
			    	xpos=move_menubar_left(xpos);
				ypos=0;
				break;
	    case '6':
	    case SL_KEY_RIGHT:	create_mainscreen();
			    	create_menubar(xpos);
				xpos=move_menubar_right(xpos);
				ypos=0;
				break;
	    case '8':
	    case SL_KEY_UP:	if (ypos == 0) {
	    			ypos=create_menu(ypos,xpos);
				ypos=1; }
		    	    	else ypos=move_menu_up(ypos,xpos);
				break;
	    case '2':
	    case SL_KEY_DOWN:	if (ypos == 0) {
				ypos=create_menu(ypos,xpos);
				ypos=1; }
				else ypos=move_menu_down(ypos,xpos);
				break;
	    case SL_KEY_NPAGE:	if (ypos == 0)
				ypos=create_menu(ypos,xpos);
				else ypos=move_menu_bottom(ypos,xpos);
				break;
	    case SL_KEY_PPAGE:	if (ypos == 0)
				ypos=create_menu(ypos,xpos);
		    	    	ypos=move_menu_top(ypos,xpos);
				break;
	    case SL_KEY_HOME:	if (ypos == 0)
				ypos=create_menu(ypos,xpos);
				ypos=move_menu_top(ypos,xpos);
				break;
	    case SL_KEY_END:	if (ypos == 0)
				ypos=create_menu(ypos,xpos);
				ypos=move_menu_bottom(ypos,xpos);
				break;
	    case '\n':
	    case '\r':		if (ypos == 0) {
				    ypos=create_menu(ypos,xpos);
				    }
				else if ((ypos==4) && (xpos==0)) {
				    demolib_exit(0);
				    }
				else {
				    input_box(10,30,3,30);
				    SLtt_beep (); 
				    }
				break;
	    default:		if ((y > ymax) || (x > xmax+2)) {
				SLsmg_write_char(ch);
				SLsmg_refresh ();}
				break;
	 }
    }
}

create_menu (int ypos, int xpos) {
    SLsmg_set_color (MBORDER);
    SLsmg_set_char_set (1);
    SLsmg_draw_box (ypos+1,xpos*8,ypos+6-ypos,9);
    SLsmg_set_char_set (0);
    SLsmg_set_color (MLOW);
  for (ypos=1; ypos < 5; ypos++) {
      SLsmg_gotorc (ypos+1, 1+xpos*8);
    SLsmg_write_string (menu[ypos][xpos]);
  }
    ypos=1;
    SLsmg_set_color(MHI);
    SLsmg_gotorc (2, 1+xpos*8);
    SLsmg_write_string (menu[ypos][xpos]);
    SLsmg_refresh ();
    return(ypos);
}

move_menu_up (int ypos, int xpos) {
        SLsmg_gotorc (ypos+1,1+xpos*8);
	SLsmg_set_color (MLOW);
	SLsmg_write_string (menu[ypos][xpos]);
	if ( ypos > 1) {
	    ypos--;
    	    SLsmg_gotorc (ypos+1,1+xpos*8);
    	    SLsmg_set_color(MHI);
	    SLsmg_write_string (menu[ypos][xpos]);
	}
	else {
    	    ypos=4;
    	    SLsmg_gotorc (ypos+1,1+xpos*8);
    	    SLsmg_set_color(MHI);
	    SLsmg_write_string (menu[ypos][xpos]);
	}
	SLsmg_refresh ();
	return(ypos);
}

move_menu_down (int ypos, int xpos) {
        SLsmg_gotorc (ypos+1,1+xpos*8);
	SLsmg_set_color (MLOW);
	SLsmg_write_string (menu[ypos][xpos]);
	if ( ypos < 4 ) {
	    ypos++;
    	    SLsmg_gotorc (ypos+1,1+xpos*8);
    	    SLsmg_set_color(MHI);
	    SLsmg_write_string (menu[ypos][xpos]);
	}
	else {
    	    ypos=1;
    	    SLsmg_gotorc (ypos+1,1+xpos*8);
    	    SLsmg_set_color(MHI);
	    SLsmg_write_string (menu[ypos][xpos]);
	}
	SLsmg_refresh ();
	return(ypos);
}


int move_menu_top (int ypos, int xpos) {
	SLsmg_set_color (MLOW);
	SLsmg_gotorc (ypos+1,1+xpos*8);
	SLsmg_write_string (menu[ypos][xpos]);
	ypos=1;
	    SLsmg_gotorc (ypos+1,1+xpos*8);
    	    SLsmg_set_color(MHI);
	    SLsmg_write_string (menu[ypos][xpos]);
	SLsmg_refresh ();
	return(ypos);
}

int move_menu_bottom (int ypos, int xpos) {
	SLsmg_set_color (MLOW);
	SLsmg_gotorc (ypos+1,1+xpos*8);
	SLsmg_write_string (menu[ypos][xpos]);
	ypos=4;
	    SLsmg_gotorc (ypos+1,1+xpos*8);
    	    SLsmg_set_color(MHI);
	    SLsmg_write_string (menu[ypos][xpos]);
	SLsmg_refresh ();
	return(ypos);
}


/* Horizontal Movement of Menubar */
move_menubar_left (int xpos) {
        SLsmg_gotorc (0,3+xpos*8);
	SLsmg_set_color (BARLOW);
	SLsmg_write_string (menu[0][xpos]);
	if ( xpos > 0) {
	    xpos--;
    	    SLsmg_gotorc (0,3+xpos*8);
    	    SLsmg_set_color(BARHI);
	    SLsmg_write_string (menu[0][xpos]);
	}
	else {
    	    xpos=3;
    	    SLsmg_gotorc (0,3+xpos*8);
    	    SLsmg_set_color(BARHI);
	    SLsmg_write_string (menu[0][xpos]);
	}
	SLsmg_refresh ();
	return(xpos);
}

move_menubar_right (int xpos) {
        SLsmg_gotorc (0,3+xpos*8);
	SLsmg_set_color (BARLOW);
	SLsmg_write_string (menu[0][xpos]);
	if ( xpos < 3) {
	    xpos++;
    	    SLsmg_gotorc (0,3+xpos*8);
    	    SLsmg_set_color(BARHI);
	    SLsmg_write_string (menu[0][xpos]);
	}
	else {
    	    xpos=0;
    	    SLsmg_gotorc (0,3+xpos*8);
    	    SLsmg_set_color(BARHI);
	    SLsmg_write_string (menu[0][xpos]);
	}
	SLsmg_refresh ();
	return(xpos);
}

create_menubar (int xpos) {
    int x = xpos;
    SLsmg_set_color (BARLOW);
    SLsmg_fill_region (0,0,1,80,' ');
    for (xpos=0;xpos < 4;xpos++) {
	SLsmg_gotorc (0,3+xpos*8);
	SLsmg_write_string (menu[0][xpos]);
	}
    SLsmg_gotorc (0,3+x*8);
    SLsmg_set_color(BARHI);
    SLsmg_write_string (menu[0][x]);
    SLsmg_refresh ();
    return(x);
}

create_mainscreen () {
  SLsig_block_signals ();
  SLsmg_cls ();
  SLtt_set_color (0, NULL, "white","black");
  SLtt_set_color (1, NULL, "black","cyan");
  SLtt_set_color (2, NULL, "yellow","black");
  SLtt_set_color (3, NULL, "white","cyan");
  SLtt_set_color (4, NULL, "yellow","cyan");
  SLtt_set_color (5, NULL, "black","lightgray");
  SLsmg_refresh ();
  SLsig_unblock_signals ();
}


input_box (int y,int x,int wid,int len) {

int ch;
    SLsig_block_signals ();
	SLsmg_set_color (MBORDER);
	SLsmg_draw_box (y,x,wid,len);
	SLsmg_set_color (5);
	SLsmg_fill_region (y+1,x+1,wid-2,len-2,' ');
	SLsmg_gotorc (11,31);
	SLsig_unblock_signals ();
	SLsmg_refresh ();
}
